
//
//
// Praktikum 2 in Algorithmen und Datenstrukturen / Fr. Prof. Dr. Kirch-Prinz
// Inhomogene Multilisten
//
// made by
//
// Rene Valdez
// Peter Ellenberg
//
//
// IML.h Headerdatei der Klassen Cell, BaseEl, ListEl
// 

#include <string>
#include <iostream>

using namespace std;

// Definiert den Pseudo Wert
#define PSEUDO -1

// Definiert den NULL Wert
#define NULL 0

// definiert aufsteigen
#define AUFSTEIGEND 0

// definiert absteigen
#define ABSTEIGEND 1

// definiert lexigraphisch
#define LEXIKON 0

// definiert numerisch
#define NUMMER 1

// definiert Name
#define NAME 0

// definiert Telefon
#define TELEFON 1

// Deklaration der Klasse Cell
class Cell {

private:

	// Link1 fr die Namen
	unsigned long link1;

	// Link2 fr die Telefonnummern
	unsigned long link2;

public:

	// Konstruktor
	Cell() { link1 = NULL; link2 = NULL; };

	// get und set Methoden
	unsigned long getLink1() {return link1; };
	unsigned long getLink2() {return link2; };
	void setLink1(Cell* vorgaenger, Cell* nachfolger) { link1 = (unsigned long)vorgaenger ^ (unsigned long)nachfolger; };
	void setLink2(Cell* vorgaenger, Cell* nachfolger) { link2 = (unsigned long)vorgaenger ^ (unsigned long)nachfolger; };

	// gibt den Pointer auf die nchste Zelle zurck (fr die Namen)
	Cell* getNextName(Cell* nachbar) { 	return (Cell*)((unsigned long)nachbar ^ link1); };

	// gibt den Pointer auf die nchste Zelle zurck (fr die Telefonnummern)
	Cell* getNextTel(Cell* nachbar) { 	return (Cell*)((unsigned long)nachbar ^ link2); };

	// virtuell definierter Konstruktor
	virtual ~Cell() {};

	// virtuell definierte display() Methode
	virtual void display() = 0;
};

// Deklaration der Klasse BaseEl
class BaseEl : public Cell {

private:
	string name;
	string telefon;
	
public:

	// Konstruktor 
	BaseEl(const string& name, string& telefon);

	// get und set Methoden
	void setName(const string& name) { this->name = name; };
	void setTel(string telefon) { this->telefon = telefon; };

	const string& getName() { return name; };
	//int	getTel() { return telefon; };
	string	getTel() { return telefon; };

	// virtuell definierte display-Methode
	void display();

};

// Deklaration der Klasse ListEl
class ListEl : public BaseEl {

private:

	// definiert die Adresse
	string adresse;

public:

	// Konstruktor
	ListEl(const string& name, string telefon, const string& adresse);

	// get und set Methoden
	void setAdresse(const string& adresse) { this->adresse = adresse; };
	string getAdresse() { return adresse; };

	// virtuell definierte display-Methode
	void display();

};

// Deklaration der Klasse InhomList
class InhomList {

private:

	// Zeiger auf die Zelle mit dem alphabetischen kleinsten Wert (Aaaa...)
	Cell* firstName;

	// Zeiger auf die Zelle mit dem numerisch kleinsten Wert (0000...)
	Cell* firstTel;

	// Zeiger auf die Zelle mit dem alphabetischen grten Wert (Zzzz...)
	Cell* lastName;

	// Zeiger auf die Zelle mit dem numerisch grten Wert (9999...)
	Cell* lastTel;

	// Anzahl der Listenelemente
	long anzahl;

	// get und set Methoden
	void setAnzahl(long anzahl) { this->anzahl = anzahl; };
	void setFirstName(Cell* cell) { firstName = cell; };
	void setFirstTel(Cell* cell) { firstTel = cell; };
	void setLastName(Cell* cell) { lastName = cell; };
	void setLastTel(Cell* cell) { lastTel = cell; };
	Cell* getFirstName() { return firstName; };
	Cell* getFirstTel() { return firstTel; };
	Cell* getLastName() { return lastName; };
	Cell* getLastTel() { return lastTel; };

	// setzt den neuen Link fr den Namen
	void insertName(Cell* cellName, Cell* nextCellName, Cell* newCell);

	// setzt den neuen Link fr die Telefonnummer
	void insertTel(Cell* cellTel, Cell* nextCellTel, Cell* newCell);

	// findet eine Zelle nach einem Name, und gibt ein Array von Pointern zurck,
	// in dem auch der Vorgnger und der Nachfolger sind
	Cell** findCellName(const string& name);

	// findet eine Zelle nach einer Telefonnummer, und gibt ein Array von Pointern zurck,
	// in dem auch der Vorgnger und der Nachfolger sind
	Cell** findCellTel(string telefon);

public:

	// Konstruktor
	InhomList();

	// fgt ein neues Element mit Adresse in die Multiliste ein
	void insert(const string& name, string telefon, const string& adresse);

	// fgt ein neues Element ohne Adresse in die Multiliste ein
	void insert(const string& name, string telefon);

	// lscht ein Element aus der Liste
	void deleteCell(const string& name);

	// druckt ein Element der Liste anhand des Namens aus
	void retrieve(const string& name, int was);

	// druckt ein Element der Liste anhand der Telefonnummer aus
//	void retrieve(string telefon);

	// druckt die gesamte Liste von vorne oder von hinten aus
	void traverse(int was, int vonWo);

	// gibt die Anzahl der Listenelemente an
	long getAnzahl() {return anzahl; };

	~InhomList();

};